!  Grid dimensions:  NX,NY,NZ - east, north, up (params.inc)
!
!  Numerical and physical constants:
!    /iconst/
!      ifile,ofile - input and output file names (6 characters)
!      isal,iconv,iekman,ispher,ipr - salinity, convection, Ekman layer
!        velocity, spherical/beta-plane, and debug print flags
!        (1=Yes,0=No; ipr=-1 => header only)
!      nt - number of timesteps for integration
!      maxits - maximum iterations for SOR solver
!      irk - timestepping scheme. See routine pgstep
!    /rconst/
!      dt - time step
!      dx,dy,dz,rdx,rdy,r2dx,r2dy - horizontal grid, 1/dx, 1/(2dx)
!      z,dzw,dzr,rdzw,rdzr,r2dzr - vertical grid
!      alx,aly,adz - Nondimensional basin widths, vertical grid param.
!      f,f1,beta - Coriolis parameter f, beta=df/dy
!      akvt,akvt - vertical temperature and salinity diffusivities
!      akht,akht - horizontal temperature and salinity diffusivities
!      alht,alht - biharmonic temperature and salinity diffusivities
!      gamma*s,gamma*b,gamma*0,*s0,*b0,*s - surface and bottom flux
!        condition constants and values
!      we0 - amplitude of Ekman layer vertical velocity forcing
!      alwe - y-wavenumber of Ekman layer vertical velocity forcing
!      de,rde - Ekman slab depth, 1/de
!      w0 - Evaporation minus precipitation (freshwater flux)
!      scap0 - reference salinity (for freshwater flux)
!      ue,ve,we - Ekman slab velocities
!      g1,g2 - coeffs for boundary solver
!      omega1,tol1 - constants for SOR elliptic solver
!      epsi,epsb,epse,depsb,depse - Horizontally variable Rayleigh
!        friction (`Ekman number') parameters
!      g1u,g2u,g1v,g2u - coefficients for velocity from pressure
!      scu,scv,csv - sec/cos arrays
!
      character*6 ifile,ofile
      common /iconst/ ifile,ofile,isal,iconv,iekman,ispher,ipr,nt
     .,               maxits,irk
      common /rconst/ dt,dx,dy,rdx,rdy,r2dx,r2dy
     .,               z(0:NZ+1),dzw(0:NZ+1),dzr(NZ)
     .,               rdzw(0:NZ+1),rdzr(NZ),r2dzr(NZ)
     .,               alx,aly,adz,f(NY),f1(NY),ys
     .,               akvt,akht,alht,akvs,akhs,alhs
     .,               gammats,gammatb,gammat0,gammass,gammasb,gammas0
     .,               ts1,ts2,yt0,tb0,ss0,sb0,ts(NX,NY),ss(NX,NY)
     .,               we0,alwe,de,rde,w00,scap0
     .,               epsi,epsb,depsb,epse,depse
     .,               ue(NX,NY),ve(NX,NY),we(NX,NY),w0(NX,NY)
     .,               omega1,tol1
     .,               g1u(NX-1,NY),g2u(NX-1,NY)
     .,               g1v(NX,NY-1),g2v(NX,NY-1)
     .,               g1(2*NY-1),g2(2*NY-1)
     .,               scu(NY),scv(NY),csv(NY)
