      subroutine pgin(t,s,r,p0)
!  Read thermocline array r, p0 from NetCDF (EPIC) format for restart
      include 'params.inc'
      include 'common.inc'
      include '/usr/local/include/netcdf.inc'
      real t(NX,NY,0:NZ+1),s(NX,NY,0:NZ+1),r(NX,NY,0:NZ+1),p0(NX,NY)
      integer  iret
! netCDF id
      integer  ncid
! dimension ids
      integer  idim,jdim,kdim,ldim
! variable ids
      integer  xid,yid,zid,timeid,v1id,v2id,v6id,v7id
! starts and counts for slabs
      integer start(1), count(1),start4(4),count4(4)
c index for ncvgt1
      integer mindex1(1)
      integer mindex4(4)
! data variables
      real*4 x(NX)
      real*4 y(NY)
      real*4 z1(NZ+2)
      real*4 value
      real*4 v0(NX,NY,NZ+2)
      integer time
! Dummy dimension name
      character*31 dimnam
!
!  Open NetCDF input file
      ncid = ncopn (ifile//'.cdf', NCNOWRIT, iret)
!  Determine dimension id's
      xid = ncdid (ncid, 'x', iret)
      yid = ncdid (ncid, 'y', iret)
      zid = ncdid (ncid, 'z', iret)
      timeid = ncdid (ncid, 'time', iret)
!  Check dimension values
      call ncdinq (ncid,xid,dimnam,idim,iret)
      call ncdinq (ncid,yid,dimnam,jdim,iret)
      call ncdinq (ncid,zid,dimnam,kdim,iret)
      call ncdinq (ncid,timeid,dimnam,ldim,iret)
      if(idim.ne.NX .or. jdim.ne.NY .or. kdim.ne.NZ+2 .or. ldim.ne.1)
     .  stop
!  Determine variable id's
      v1id = ncvid (ncid, 'rho', iret)
      v2id = ncvid (ncid, 'p', iret)
      if(isal.eq.1) then
       v6id = ncvid (ncid, 't', iret)
       v7id = ncvid (ncid, 's', iret)
      endif
!  Get the entire slab in v0, then store
      start4(1)=1
      start4(2)=1
      start4(3)=1
      start4(4)=1
      count4(1)=NX
      count4(2)=NY
      count4(3)=NZ+2
      count4(4)=1
!  Get rho
      call ncvgt(ncid, v1id, start4, count4, v0, iret)
      do k=1,NZ+1
       do j=1,NY
        do i=1,NX
         r(i,j,k)=dble(v0(i,j,k+1))
        enddo
       enddo
      enddo
!  Get p0 from p(i,j,k=NZ+2)
      call ncvgt(ncid, v2id, start4, count4, v0, iret)
      do j=1,NY
       do i=1,NX
        p0(i,j)=dble(v0(i,j,NZ+2))
       enddo
      enddo
!  Temperature and salinity
      if(isal.eq.1) then
       call ncvgt(ncid, v6id, start4, count4, v0, iret)
       do k=1,NZ+1
        do j=1,NY
         do i=1,NX
          t(i,j,k)=dble(v0(i,j,k+1))
         enddo
        enddo
       enddo
       call ncvgt(ncid, v7id, start4, count4, v0, iret)
       do k=1,NZ+1
        do j=1,NY
         do i=1,NX
          s(i,j,k)=dble(v0(i,j,k+1))
         enddo
        enddo
       enddo
      else
       do k=1,NZ+1
        do j=1,NY
         do i=1,NX
          t(i,j,k)=-r(i,j,k)
         enddo
        enddo
       enddo
      endif
!  Close ncdf file
      call ncclos(ncid,iret)
      return
      end
!
! ----------------------------------------------------------------
!
      subroutine pgout(it,time,t,s,r,p0,p,u,v,w)
!  Write thermocline arrays in NetCDF (EPIC) format
      include 'params.inc'
      include 'common.inc'
      include '/usr/local/include/netcdf.inc'
      real t(NX,NY,0:NZ+1),s(NX,NY,0:NZ+1)
      real r(NX,NY,0:NZ+1),p0(NX,NY),p(NX,NY,NZ+1)
      real u(NX,NY,NZ+1),v(NX,NY,NZ+1),w(NX,NY,0:NZ+1)
      integer  iret
! netCDF id
      integer  ncid
! dimension ids
      integer  idim,jdim,kdim,ldim
! variable ids
      integer  xid,yid,zid,timeid,v1id,v2id,v3id,v4id,v5id,v6id,v7id
! variable shapes
      integer dims(4)
! starts and counts
      integer start(1), count(1),start4(4),count4(4)
c index for ncvpt1
      integer mindex1(1)
      integer mindex4(4)
! data variables
      real*4 x(NX)
      real*4 y(NY)
      real*4 z1(NZ+2)
      real*4 value
      real*4 v0(NX*NY*(NZ+2)*1)
      integer time
! attribute vectors
      integer  longval(1)
c
      pi=atan2(0.,-1.)
! enter define mode
      ncid = nccre (ofile//'.cdf', NCCLOB, iret)
! define dimensions
      idim = ncddef(ncid, 'x', NX, iret)
      jdim = ncddef(ncid, 'y', NY, iret)
      kdim = ncddef(ncid, 'z', NZ+2, iret)
!*********************************************************************
! inserted by S.-K. Lee (May/19/2009)
!     ldim = ncddef(ncid, 'time',1        iret)
      ldim = ncddef(ncid, 'time',NCUNLIM, iret)
!*********************************************************************
! define variables
      dims(1) = idim
      xid = ncvdef (ncid, 'x', NCFLOAT, 1, dims, iret)
      dims(1) = jdim
      yid = ncvdef (ncid, 'y', NCFLOAT, 1, dims, iret)
      dims(1) = kdim
      zid = ncvdef (ncid, 'z', NCFLOAT, 1, dims, iret)
      dims(1) = ldim
      timeid = ncvdef (ncid, 'time', NCLONG, 1, dims, iret)
      dims(4) = ldim
      dims(3) = kdim
      dims(2) = jdim
      dims(1) = idim
      v1id = ncvdef (ncid, 'rho', NCFLOAT, 4, dims, iret)
      v2id = ncvdef (ncid, 'p', NCFLOAT, 4, dims, iret)
      v3id = ncvdef (ncid, 'u', NCFLOAT, 4, dims, iret)
      v4id = ncvdef (ncid, 'v', NCFLOAT, 4, dims, iret)
      v5id = ncvdef (ncid, 'w', NCFLOAT, 4, dims, iret)
      if(isal.eq.1) then
       v6id = ncvdef (ncid, 't', NCFLOAT, 4, dims, iret)
       v7id = ncvdef (ncid, 's', NCFLOAT, 4, dims, iret)
      endif
! assign attributes
      call ncaptc(ncid, xid, 'units', NCCHAR, 2, 'L0', iret)
      call ncaptc(ncid, yid, 'units', NCCHAR, 2, 'L0', iret)
      call ncaptc(ncid, zid, 'units', NCCHAR, 1, 'D', iret)
      call ncaptc(ncid, timeid, 'units', NCCHAR, 1, 'T', iret)
      longval(1) = 501
      call ncapt(ncid, xid, 'epic_code', NCLONG, 1, longval, iret)
      longval(1) = 500
      call ncapt(ncid, yid, 'epic_code', NCLONG, 1, longval, iret)
      longval(1) = 1
      call ncapt(ncid, zid, 'epic_code', NCLONG, 1, longval, iret)
      longval(1) = 625
      call ncapt(ncid, timeid, 'epic_code', NCLONG, 1, longval, iret)
! assign variable attributes
      call ncaptc(ncid, v1id, 'units', NCCHAR, 4, 'Rho0', iret)
      call ncaptc(ncid, v1id, 'long_name', NCCHAR, 7, 'Density', iret)
      call ncaptc(ncid, v2id, 'units', NCCHAR, 5, 'Rho0D', iret)
      call ncaptc(ncid, v2id, 'long_name', NCCHAR, 8, 'Pressure', iret)
      call ncaptc(ncid, v3id, 'units', NCCHAR, 1, 'U', iret)
      call ncaptc(ncid, v3id, 'long_name', NCCHAR, 1, 'u', iret)
      call ncaptc(ncid, v4id, 'units', NCCHAR, 1, 'U', iret)
      call ncaptc(ncid, v4id, 'long_name', NCCHAR, 1, 'v', iret)
      call ncaptc(ncid, v5id, 'units', NCCHAR, 4, 'DU/L', iret)
      call ncaptc(ncid, v5id, 'long_name', NCCHAR, 1, 'w', iret)
      if(isal.eq.1) then
       call ncaptc(ncid, v6id, 'units', NCCHAR, 2, 'T0', iret)
       call ncaptc(ncid, v6id, 'long_name', NCCHAR, 1, 't', iret)
       call ncaptc(ncid, v7id, 'units', NCCHAR, 2, 'S0', iret)
       call ncaptc(ncid, v7id, 'long_name', NCCHAR, 1, 's', iret)
      endif
! global attributes
      call ncaptc(ncid,NCGLOBAL,'DATA_TYPE',NCCHAR,5,'MODEL',iret)
      call ncaptc(ncid,NCGLOBAL,'COORD_SYSTEM',NCCHAR,5,'LOCAL',iret)
! leave define mode
      call ncendf(ncid, iret)
! store x
      start(1) = 1
      count(1) = NX
      if(ispher.eq.1) then
       rd2dgr=180./pi
      else
       rd2dgr=1.
      endif
      do i=1,NX
       x(i)=(float(i-1)-0.5)*dx*rd2dgr
      enddo
      call ncvpt(ncid, xid, start, count, x, iret)
! store y
      start(1) = 1
      count(1) = NY
      do j=1,NY
       y(j)=(ys+(float(j-1)-0.5)*dy)*rd2dgr
      enddo
      call ncvpt(ncid, yid, start, count, y, iret)
! store z
      start(1) = 1
      count(1) = NZ+2
      do k=1,NZ+2
       z1(k)=sngl(z(k-1))
      enddo
      call ncvpt(ncid, zid, start, count, z1, iret)
! store time
      mindex1(1) = 1
      time=it
      call ncvpt1(ncid, timeid, mindex1, time, iret)
!  Store values in ncdf file
!  Store rho
      start4(1)=1
      start4(2)=1
      start4(3)=1
      start4(4)=1
      count4(1)=NX
      count4(2)=NY
      count4(3)=NZ+2
      count4(4)=1
      do 14 k=0,NZ+1
       do 14 j=1,NY
        do 14 i=1,NX
         v0(i+(j-1)*NX+k*NY*NX)=sngl(r(i,j,k))
14    continue
      call ncvpt(ncid, v1id, start4, count4, v0, iret)
!  Store p, p0
      start4(1)=1
      start4(2)=1
      start4(3)=2
      start4(4)=1
      count4(1)=NX
      count4(2)=NY
      count4(3)=NZ+1
      count4(4)=1
      do 20 k=1,NZ
       do 20 j=1,NY
        do 20 i=1,NX
         v0(i+(j-1)*NX+(k-1)*NY*NX)=sngl(p(i,j,k))
20    continue
      do 22 j=1,NY
       do 22 i=1,NX
        v0(i+(j-1)*NX+NZ*NY*NX)=sngl(p0(i,j))
22    continue
      call ncvpt(ncid, v2id, start4, count4, v0, iret)
!  Store u,v -- interpolate to rho points
      start4(1)=2
      start4(2)=2
      start4(3)=2
      start4(4)=1
      count4(1)=NX-2
      count4(2)=NY-2
      count4(3)=NZ+1
      count4(4)=1
      do 30 k=1,NZ+1
       do 30 j=2,NY-1
        do 30 i=2,NX-1
         v0(i-1+(j-2)*(NX-2)+(k-1)*(NY-2)*(NX-2))=
     .          0.5*sngl(u(i,j,k)+u(i-1,j,k))
30    continue
      call ncvpt(ncid, v3id, start4, count4, v0, iret)
      do 40 k=1,NZ+1
       do 40 j=2,NY-1
        do 40 i=2,NX-1
         v0(i-1+(j-2)*(NX-2)+(k-1)*(NY-2)*(NX-2))=
     .          0.5*sngl(v(i,j,k)+v(i,j-1,k))
40    continue
      call ncvpt(ncid, v4id, start4, count4, v0, iret)
!  Store w -- interpolate interior values to rho points
      start4(1)=2
      start4(2)=2
      start4(3)=1
      start4(4)=1
      count4(1)=NX-2
      count4(2)=NY-2
      count4(3)=NZ+2
      count4(4)=1
!  Store w top and bottom
      do 50 j=2,NY-1
       do 50 i=2,NX-1
        v0(i-1+(j-2)*(NX-2))=sngl(w(i,j,0))
        v0(i-1+(j-2)*(NX-2)+(NZ+1)*(NY-2)*(NX-2))=sngl(w(i,j,NZ+1))
!   Reset top w for vertical average below
!        w(i,j,NZ)=w(i,j,NZ+1)
50    continue
      do 52 k=1,NZ
       do 52 j=2,NY-1
        do 52 i=2,NX-1
         v0(i-1+(j-2)*(NX-2)+k*(NY-2)*(NX-2))=
     .      0.5*sngl(w(i,j,k)+w(i,j,k-1))
52    continue
      call ncvpt(ncid, v5id, start4, count4, v0, iret)
!  Store t, s 
      if(isal.eq.1) then
       start4(1)=1
       start4(2)=1
       start4(3)=1
       start4(4)=1
       count4(1)=NX
       count4(2)=NY
       count4(3)=NZ+2
       count4(4)=1
       do 60 k=0,NZ+1
        do 60 j=1,NY
         do 60 i=1,NX
          v0(i+(j-1)*NX+k*NY*NX)=sngl(t(i,j,k))
60     continue
       call ncvpt(ncid, v6id, start4, count4, v0, iret)
       do 70 k=0,NZ+1
        do 70 j=1,NY
         do 70 i=1,NX
          v0(i+(j-1)*NX+k*NY*NX)=sngl(s(i,j,k))
70     continue
       call ncvpt(ncid, v7id, start4, count4, v0, iret)
      endif
!  Close ncdf file
      call ncclos(ncid,iret)
      return
      end
