#! /bin/csh
#
cat > params.inc <<EOF
!  Grid dimensions:  NX,NY,NZ - east, north, up
!       parameter (NX=20,NY=20,NZ=14)
!       parameter (NX=28,NY=28,NZ=14)
!       parameter (NX=33,NY=33,NZ=16)
!       parameter (NX=33,NY=33,NZ=32)
!       parameter (NX=56,NY=56,NZ=28)
!       parameter (NX=33,NY=33,NZ=14)
        parameter (NX=65,NY=65,NZ=32)
!       parameter (NX=65,NY=65,NZ=64)
        parameter (KTOT=2*(NX+NY-2) )
EOF
#
rm -f *.o
make
#
@ nrun = 200
@ nt   = 2000
#
# --- RUN PGOM -------------------------------------------------------
#
echo '                 '
echo ' PGOM RUN STRATED'
echo '                 '
#
cat > const.name << EOF
 &constn  
          ifile=' ',ofile='carte1',
          isal=0,iconv=1,iekman=1,ispher=0,ipr=0,
          nt=$nt,t0=1,dt=5.0e-6,irk=0,
          alx=1.,aly=1.,adz=3.,ys=0.,f0=1.,beta=1.1,
          akvt=0.02,akht=0.3,alht=-99.,
          akvs=0.02,akhs=0.3,alhs=-99.,
          gammats=5.,gammatb=0.,gammat0=2.,
          gammass=0.,gammasb=0.,gammas0=2.,
          ts1=100.,ts2=-100.,yt0=0.50,tb0=0.,
          ss0=0.,sb0=0.,scap0=2800.,
          we0=0.,alwe=2.,de=0.005,w00=0.,
          epsi=0.0124,epsb=0.0124,depsb=0.1,epse=0.0124,depse=0.1,
          omega1=1.2,tol1=1.e-11,maxits=5000
 &end
EOF
nice pgom11.x 
cp carte1.cdf carte1_0001.nc
#
@ m0 = 2
while ($m0 <= $nrun)
#
if ($m0 <=   9             ) set mrun = 000${m0}
if ($m0 >    9 & $m0 <=  99) set mrun =  00${m0}
if ($m0 >   99 & $m0 <= 999) set mrun =   0${m0}
if ($m0 >  999             ) set mrun =    ${m0}
#
cat > const.name << EOF
 &constn  ifile='carte1',ofile='carte1',
          isal=0,iconv=1,iekman=1,ispher=0,ipr=0,
          nt=$nt,t0=$m0,dt=5.0e-6,irk=0,
          alx=1.,aly=1.,adz=3.,ys=0.,f0=1.,beta=1.1,
          akvt=0.02,akht=0.3,alht=-99.,
          akvs=0.02,akhs=0.3,alhs=-99.,
          gammats=5.,gammatb=0.,gammat0=2.,
          gammass=0.,gammasb=0.,gammas0=2.,
          ts1=100.,ts2=-100.,yt0=0.50,tb0=0.,
          ss0=0.,sb0=0.,scap0=2800.,
          we0=0.,alwe=2.,de=0.005,w00=0.,
          epsi=0.0124,epsb=0.0124,depsb=0.1,epse=0.0124,depse=0.1,
          omega1=1.2,tol1=1.e-11,maxits=5000
 &end
EOF
#
nice pgom11.x 
cp carte1.cdf carte1_${mrun}.nc
#
@ m0 = $m0 + 1
end
exit 0
